/**	
*   @file	ADistance.cpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\AGraphic.hpp>
#include <GOMLib\PMath.hpp>

#include <GOMLib\ADistance.hpp>


/**
*  Constructor
*/
ADistance::ADistance()
{
	d = -1;
}


/**
*  Constructor
*/
ADistance::ADistance(double d)
{
	this->d = d;
}


/**
*  Destructor
*/
ADistance::~ADistance()
{
}


/**
*  GOM output
*/
void ADistance::gomo(ostream & os)
{
	os << getName() << " " << d << endl;
}


/**
*  GOM input
*/
void ADistance::gomi(istream & is)
{
	is >> d;
}


/**
*  XML output
*/
void ADistance::xmlo(ostream & os)
{
	os	<< "<" << getName() << " distance=\"" << d << "\"/>" << endl;
}
