/**	
*   @file	AGraphic.cpp
*	@author	Mathieu Delalandre
*	@date	05/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\AGraphic.hpp>

#include <GOMLib\PMath.hpp>

#include <GOMLib\AGraphicImpl.hpp>
#include <GOMLib\AAngle.hpp>
#include <GOMLib\ADistance.hpp>
#include <GOMLib\ALabel.hpp>
#include <GOMLib\ALink.hpp>


/**
*  Destructor
*/
AGraphic::~AGraphic()
{
}


/**
*  Get name
*/
string AGraphic::getName()
{
	string s = typeid(*this).name();
	s.erase(0,6);
	return s;
}


/**
*  Print
*/
void AGraphic::print()
{
	//gomo(cout);
	xmlo(cout);
}


/**
*  Attribute create (string)
*/
AGraphic* AGraphic::aCreate(string & aname)
{
	if(aname == "AAngle")
		return new AAngle();
	else if(aname == "ADistance")
		return new ADistance();
	else if(aname == "ALabel")
		return new ALabel();
	else if(aname == "ALink")
		return new ALink();
	else
		return new AGraphicImpl();
}

