/**	
*   @file	ALabel.cpp
*	@author	Mathieu Delalandre
*	@date	05/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\AGraphic.hpp>
#include <GOMLib\ALabel.hpp>


/**
*  Constructor
*/
ALabel::ALabel()
{
	label = "none";
}


/**
*  Constructor (string)
*/
ALabel::ALabel(char* cN)
{
	string sN(cN); 
	if(sN.length() != 0)
		this->label = sN;
}


/**
*  Constructor (string)
*/
ALabel::ALabel(string & label)
{
	if(label.length() != 0)
		this->label = label;
}


/**
*  Destructor
*/
ALabel::~ALabel()
{
}


/**
*  GOM output
*/
void ALabel::gomo(ostream & os)
{
	os << getName() << " " << label << endl;
}


/**
*  GOM input
*/
void ALabel::gomi(istream & is)
{
	is >> label;
}


/**
*  XML output
*/
void ALabel::xmlo(ostream & os)
{
	os	<< "<" << getName() << " label=\"" << label << "\"/>" << endl;
}


