/**	
*   @file	ALink.cpp
*	@author	Mathieu Delalandre
*	@date	05/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\AGraphic.hpp>

#include <GOMLib\ALink.hpp>


/**
*  Static member
*/
int ALink::begin = 0;
int ALink::center = 1;
int ALink::end = 2;


/**
*  Constructor
*/
ALink::ALink()
{
	from = end; to = begin;
}


/**
*  Constructor
*/
ALink::ALink(int from,int to)
{
	this->from = from; this->to = to;
}


/**
*  Destructor
*/
ALink::~ALink()
{
}


/**
*  GOM output
*/
void ALink::gomo(ostream & os)
{
	os << getName() << " " << from << " " << to << endl;
}


/**
*  GOM input
*/
void ALink::gomi(istream & is)
{
	is >> from; is >> to;
}


/**
*  XML output
*/
void ALink::xmlo(ostream & os)
{
	os	<< "<" << getName() << " from=\"" << linkLabel(from) << "\" to=\"" << linkLabel(to) << "\"/>" << endl;
}


/**
*  Link label
*/
string ALink::linkLabel(int v)
{
	if(v==begin)
		return "begin";
	else if(v==center)
		return "center";
	else
		return "end";
}
