/**	
*   @file	ODPoint.cpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/

#include <iostream>
#include <string>
#include <math.h>

using namespace std;

#include <GOMLib\OGraphic.hpp>

#include <GOMLib\OPoint.hpp>
#include <GOMLib\ODPoint.hpp>


/**
*  Constructor
*/
ODPoint::ODPoint() : OPoint()
{
	d = -1;
}


/**
*  Constructor
*/
ODPoint::ODPoint(int x, int y, int d) : OPoint(x,y)
{
	this->d = d;
}


/**
*  Constructor
*/
ODPoint::ODPoint(OPoint & p, int d) : OPoint(p.getX(),p.getY())
{
	this->d = d;
}


/**
*  Destructor
*/
ODPoint::~ODPoint()
{
}


/**
*  Is valid
*/
bool ODPoint::isValid()
{ 
	if((x>=0)&&(y>=0)&&(d>=1))
		return true;
	return false;
}


/**
*  Move
*/
void ODPoint::move(int dx,int dy,int dd)
{ 
	x += dx;
	y += dy;
	d += dd ;
}


/**
*  == operator
*/
bool ODPoint::operator == (ODPoint & p)
{
	if((x == p.getX())&&(y == p.getY())&&(d == p.getDepth()))
		return true;
	return false;
}


/**
*  != operator
*/
bool ODPoint::operator != (ODPoint & p)
{
	if((x != p.getX())||(y != p.getY())&&(d != p.getDepth()))
		return true;
	return false;
}


/**
*  GOM output
*/
void ODPoint::gomo(ostream & os)
{
	os << getName() << " " << x << " " << y << " " << d << endl;
}


/**
*  GOM input
*/
void ODPoint::gomi(istream & is)
{
	is >> x; is >> y; is >> d;
}


/**
*  XML output
*/
void ODPoint::xmlo(ostream & os)
{
	os	<< "<" 
		<< getName() 
		<< " x=\"" << x << "\"" 
		<< " y=\"" << y << "\""
		<< " d=\"" << d << "\""
		<< "/>" << endl;  
}


