/**	
*   @file	OJunction.cpp
*	@author	Mathieu Delalandre
*	@date	05/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\OGraphic.hpp>
#include <GOMLib\OPoint.hpp>
#include <GOMLib\OExtremity.hpp>


/**
*  Constructor
*/
OExtremity::OExtremity() : OPoint()
{
}


/**
*  Constructor
*/
OExtremity::OExtremity(int x,int y) : OPoint(x,y)
{
}


/**
*  Constructor
*/
OExtremity::OExtremity(OPoint & p) : OPoint(p.getX(),p.getY())
{
}


/**
*  Destructor
*/
OExtremity::~OExtremity()
{
}


/**
*  SVG output
*/
void OExtremity::svgo(ostream & os)
{
	if(isValid())
		os	<<	"<line"
			<<	" x1=\"" << x << "\" y1=\"" << y << "\""
			<<	" x2=\"" << x+1 << "\" y2=\"" << y << "\""
			<<	" style=\"fill:none; stroke:yellow; stroke-width:1\""
			<<	"/>" << endl ;
}
