/**	
*   @file	OGraphic.cpp
*	@author	Mathieu Delalandre, Sebastien Perin
*	@date	05/2004	
*/

#include <iostream>
#include <typeinfo>
#include <deque>
#include <GTL\graph.h>

using namespace std;

#include <GOMLib\OGraphic.hpp>
#include <GOMLib\AGraphic.hpp>
#include <GOMLib\OGraphicImpl.hpp>
#include <GOMLib\AGraphicImpl.hpp>

#include <GOMLib\OPoint.hpp>
#include <GOMLib\ODPoint.hpp>
#include <GOMLib\OLPoint.hpp>
#include <GOMLib\OVPoint.hpp>
#include <GOMLib\OLine.hpp>
#include <GOMLib\OArc.hpp>
#include <GOMLib\OCurve.hpp>
#include <GOMLib\OQuadrilateral.hpp>
#include <GOMLib\OHL.hpp>
#include <GOMLib\OGraph.hpp>
#include <GOMLib\OJunction.hpp>
#include <GOMLib\OExtremity.hpp>


/**
*  Destructor
*/
OGraphic::~OGraphic()
{
}

/**
*  Get name
*/
string OGraphic::getName()
{
	string s = typeid(*this).name();
	s.erase(0,6);
	return s;
}

/**
*  Print
*/
void OGraphic::print()
{
	//gomo(cout);
	xmlo(cout);
}


/**
*  Object create (string)
*/
OGraphic* OGraphic::oCreate(string & oname)
{
	if(oname == "OPoint")
		return new OPoint();
	
	else if(oname == "ODPoint")
		return new ODPoint();
	
	else if(oname == "OLPoint")
		return new OLPoint();
	
	else if(oname == "OVPoint")
		return new OVPoint();
	
	else if(oname == "OLine")
		return new OLine();
	
	else if(oname == "OArc")
		return new OArc();
	
	else if(oname == "OCurve")
		return new OCurve();
	
	else if(oname == "OQuadrilateral")
		return new OQuadrilateral();

	else if(oname == "OHL")
		return new OHL();
	
	else if(oname == "OGraph")
		return new OGraph();
	
	else if(oname == "OJunction")
		return new OJunction();

	else if(oname == "OExtremity")
		return new OExtremity();

	else
		return new OGraphicImpl();
}

