/**	
*   @file	OIPoint.cpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\OGraphic.hpp>
#include <GOMLib\OPoint.hpp>
#include <GOMLib\OIPoint.hpp>


/**
*  Constructor
*/
OIPoint::OIPoint() : OPoint()
{
}


/**
*  Constructor
*/
OIPoint::OIPoint(int x,int y) : OPoint(x,y)
{
}


/**
*  Constructor
*/
OIPoint::OIPoint(OPoint & p) : OPoint(p.getX(),p.getY())
{
}


/**
*  Destructor
*/
OIPoint::~OIPoint()
{
}


/**
*  SVG output
*/
void OIPoint::svgo(ostream & os)
{
	if(isValid())
		os	<<	"<line"
			<<	" x1=\"" << x << "\" y1=\"" << y << "\""
			<<	" x2=\"" << x+1 << "\" y2=\"" << y << "\""
			<<	" style=\"fill:none; stroke:green; stroke-width:1\""
			<<	"/>" << endl ;
}
