/**	
*   @file	OJunction.cpp
*	@author	Mathieu Delalandre
*	@date	05/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\OGraphic.hpp>
#include <GOMLib\OPoint.hpp>
#include <GOMLib\OJunction.hpp>


/**
*  Constructor
*/
OJunction::OJunction() : OPoint()
{
}


/**
*  Constructor
*/
OJunction::OJunction(int x,int y) : OPoint(x,y)
{
}


/**
*  Constructor
*/
OJunction::OJunction(OPoint & p) : OPoint(p.getX(),p.getY())
{
}


/**
*  Destructor
*/
OJunction::~OJunction()
{
}


/**
*  SVG output
*/
void OJunction::svgo(ostream & os)
{
	if(isValid())
		os	<<	"<line"
			<<	" x1=\"" << x << "\" y1=\"" << y << "\""
			<<	" x2=\"" << x+1 << "\" y2=\"" << y << "\""
			<<	" style=\"fill:none; stroke:red; stroke-width:1\""
			<<	"/>" << endl ;
}
