/**	
*   @file	OLPoint.cpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/

#include <iostream>
#include <string>

using namespace std;

#include <GOMLib\OGraphic.hpp>
#include <GOMLib\OPoint.hpp>
#include <GOMLib\OLPoint.hpp>


/**
*  Constructor
*/
OLPoint::OLPoint() : OPoint()
{
	label = "none";
}


/**
*  Constructor
*/
OLPoint::OLPoint(int x,int y,string & label) : OPoint(x,y)
{
	this->label = label;
}


/**
*  Constructor
*/
OLPoint::OLPoint(OPoint & p, string & label) : OPoint(p.getX(),p.getY())
{
	this->label = label;
}


/**
*  Destructor
*/
OLPoint::~OLPoint()
{
}


/**
*  Is valid
*/
bool OLPoint::isValid()
{ 
	if((x>=0)&&(y>=0)&&(label!="none"))
		return true;
	return false;
}


/**
*  GOM output
*/
void OLPoint::gomo(ostream & os)
{
	os << getName() << " " << x << " " << y << " " << label << endl;
}


/**
*  GOM input
*/
void OLPoint::gomi(istream & is)
{
	is >> x;
	is >> y;
	is >> label;
}


/**
*  XML output
*/
void OLPoint::xmlo(ostream & os)
{
	os	<< "<" << getName() 
		<< " x=\"" << x << "\""
		<< " y=\"" << y << "\""
		<< " label=\"" << label << "\""
		<< "/>" << endl;  
}


/**
*  SVG output
*/
void OLPoint::svgo(ostream & os)
{
	if(isValid())
		{
		os	<<	"<line"
			<<	" x1=\"" << x << "\" y1=\"" << y << "\""
			<<	" x2=\"" << x+1 << "\" y2=\"" << y << "\""
			<<	" style=\"fill:none; stroke:red; stroke-width:1\""
			<<	"/>" << endl ;
		os	<< 	"<text"
			<<	" x=\"" << x << "\" y=\"" << y << "\""
			<<	" style=\"font-family:Verdana; font-size:3pt; fill:black\""
			<<	">"
			<<	label
			<<	"</text>" << endl;
		}
}
