/**	
*   @file	PAUtility.cpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/

#include <iostream>
#include <fstream>
#include <string> 
#include <deque>
#include <GTL\graph.h>

using namespace std;

#include <GOMLib\OGraphic.hpp>
#include <GOMLib\AGraphic.hpp>

#include <GOMLib\PMath.hpp>

#include <GOMLib\AGraphicImpl.hpp>
#include <GOMLib\ADistance.hpp>
#include <GOMLib\AAngle.hpp>
#include <GOMLib\ALabel.hpp>

#include <GOMLib\PAUtility.hpp>


/**
* Attribute to AGraphic
*/
AGraphic* castAGraphic(AGraphicImpl* a)
{
	return dynamic_cast<AGraphic*>(a);
}
AGraphic* castAGraphic(ADistance* a)
{
	return dynamic_cast<AGraphic*>(a);
}
AGraphic* castAGraphic(AAngle* a)
{
	return dynamic_cast<AGraphic*>(a);
}
AGraphic* castAGraphic(ALabel* a)
{
	return dynamic_cast<AGraphic*>(a);
}
/**
* AGraphic to Attribute
*/
AGraphicImpl* castOGraphicImpl(AGraphic* a)
{
	if(a->getName()=="AGraphicImpl")
		return dynamic_cast<AGraphicImpl*>(a);
	return NULL;
}
ADistance* castOGraphicImpl(ADistance* a)
{
	if(a->getName()=="ADistance")
		return dynamic_cast<ADistance*>(a);
	return NULL;
}
AAngle* castOGraphicImpl(AAngle* a)
{
	if(a->getName()=="AAngle")
		return dynamic_cast<AAngle*>(a);
	return NULL;
}
ALabel* castOGraphicImpl(ALabel* a)
{
	if(a->getName()=="ALabel")
		return dynamic_cast<ALabel*>(a);
	return NULL;
}
/**
* Attribute array to AGraphic array
*/
deque<AGraphic*> castAGraphicArray(deque<AGraphicImpl*> & a)
{
	deque<AGraphic*> aa;
	for(int i=0;i<a.size();i++)
		aa.push_back(dynamic_cast<AGraphic*>(a[i]));
	return aa;
}
deque<AGraphic*> castAGraphicArray(deque<ADistance*> & a)
{
	deque<AGraphic*> aa;
	for(int i=0;i<a.size();i++)
		aa.push_back(dynamic_cast<AGraphic*>(a[i]));
	return aa;
}
deque<AGraphic*> castAGraphicArray(deque<AAngle*> & a)
{
	deque<AGraphic*> aa;
	for(int i=0;i<a.size();i++)
		aa.push_back(dynamic_cast<AGraphic*>(a[i]));
	return aa;
}
deque<AGraphic*> castAGraphicArray(deque<ALabel*> & a)
{
	deque<AGraphic*> aa;
	for(int i=0;i<a.size();i++)
		aa.push_back(dynamic_cast<AGraphic*>(a[i]));
	return aa;
}
/**
* AGraphic array to Attribute array
*/
deque<AGraphicImpl*> castAGraphicImplArray(deque<AGraphic*> & a)
{
	deque<AGraphicImpl*> aa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="AGraphicImpl")
			aa.push_back(dynamic_cast<AGraphicImpl*>(a[i]));
	return aa;
}
deque<ADistance*> castADistanceArray(deque<AGraphic*> & a)
{
	deque<ADistance*> aa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="ADistance")
			aa.push_back(dynamic_cast<ADistance*>(a[i]));
	return aa;
}
deque<AAngle*> castAAngleArray(deque<AGraphic*> & a)
{
	deque<AAngle*> aa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="AAngle")
			aa.push_back(dynamic_cast<AAngle*>(a[i]));
	return aa;
}
deque<ALabel*> castALabelArray(deque<ALabel*> & a)
{
	deque<ALabel*> aa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="ALabel")
			aa.push_back(dynamic_cast<ALabel*>(a[i]));
	return aa;
}
/**
* AGraphic array print
*/
void printAGraphicArray(deque<AGraphic*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printAGraphicArray(deque<ADistance*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printAGraphicArray(deque<AAngle*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printAGraphicArray(deque<ALabel*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
