/**	
*   @file	POUtility.cpp
*	@author	Mathieu Delalandre
*	@date	05/2004	
*/

#include <iostream>
#include <fstream>
#include <string> 
#include <deque>
#include <GTL\graph.h>

using namespace std;

#include <GOMLib\OGraphic.hpp>
#include <GOMLib\AGraphic.hpp>
#include <GOMLib\OGraphicImpl.hpp>
#include <GOMLib\AGraphicImpl.hpp>

#include <GOMLib\OPoint.hpp>
#include <GOMLib\ODPoint.hpp>
#include <GOMLib\OLPoint.hpp>
#include <GOMLib\OVPoint.hpp>
#include <GOMLib\OLine.hpp>
#include <GOMLib\OArc.hpp>
#include <GOMLib\OCurve.hpp>
#include <GOMLib\OHL.hpp>
#include <GOMLib\OGraph.hpp>
#include <GOMLib\OIPoint.hpp>
#include <GOMLib\OExtremity.hpp>
#include <GOMLib\OJunction.hpp>

#include <GOMLib\OQuadrilateral.hpp> //modification

#include <GOMLib\POUtility.hpp>

/**
* Object to OGraphic
*/
OGraphic* castOGraphic(OGraphicImpl* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OPoint* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(ODPoint* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OLPoint* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OVPoint* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OLine* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OArc* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OCurve* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OHL* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OGraph* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OJunction* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OExtremity* o)
{
	return dynamic_cast<OGraphic*>(o);
}
OGraphic* castOGraphic(OIPoint* o)
{
	return dynamic_cast<OGraphic*>(o);
}


OGraphic* castOGraphic(OQuadrilateral* o)
{
	return dynamic_cast<OGraphic*>(o);
}
/**
* OGraphic to Object
*/
OGraphicImpl* castOGraphicImpl(OGraphic* o)
{
	if(o->getName()=="OGraphicImpl")
		return dynamic_cast<OGraphicImpl*>(o);
	return NULL;
}
OPoint* castOPoint(OGraphic* o)
{
	if(o->getName()=="OPoint")
		return dynamic_cast<OPoint*>(o);
	return NULL;
}
ODPoint* castODPoint(OGraphic* o)
{
	if(o->getName()=="ODPoint")
		return dynamic_cast<ODPoint*>(o);
	return NULL;
}
OLPoint* castOLPoint(OGraphic* o)
{
	if(o->getName()=="OLPoint")
		return dynamic_cast<OLPoint*>(o);
	return NULL;
}
OVPoint* castOVPoint(OGraphic* o)
{
	if(o->getName()=="OVPoint")
		return dynamic_cast<OVPoint*>(o);
	return NULL;
}
OLine* castOLine(OGraphic* o)
{
	if(o->getName()=="OLine")
		return dynamic_cast<OLine*>(o);
	return NULL;
}
OArc* castOArc(OGraphic* o)
{
	if(o->getName()=="OArc")
		return dynamic_cast<OArc*>(o);
	return NULL;
}
OCurve* castOCurve(OGraphic* o)
{
	if(o->getName()=="OCurve")
		return dynamic_cast<OCurve*>(o);
	return NULL;
}
OHL* castOHL(OGraphic* o)
{
	if(o->getName()=="OHL")
		return dynamic_cast<OHL*>(o);
	return NULL;
}
OGraph* castOGraph(OGraphic* o)
{
	if(o->getName()=="OGraph")
		return dynamic_cast<OGraph*>(o);
	return NULL;
}
OIPoint* castOIPoint(OGraphic* o)
{
	if(o->getName()=="OIPoint")
		return dynamic_cast<OIPoint*>(o);
	return NULL;
}
OExtremity* castOExtremity(OGraphic* o)
{
	if(o->getName()=="OExtremity")
		return dynamic_cast<OExtremity*>(o);
	return NULL;
}
OJunction* castOJunction(OGraphic* o)
{
	if(o->getName()=="OJunction")
		return dynamic_cast<OJunction*>(o);
	return NULL;
}


OQuadrilateral* castOQuadrilateral(OGraphic* o)
{
	if(o->getName()=="OQuadrilateral")
		return dynamic_cast<OQuadrilateral*>(o);
	return NULL;
}
/**
* Object array to OGraphic array
*/
deque<OGraphic*> castOGraphicArray(deque<OGraphicImpl*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OPoint*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<ODPoint*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OLPoint*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OVPoint*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OLine*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OArc*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OCurve*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OHL*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OGraph*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OIPoint*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OExtremity*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
deque<OGraphic*> castOGraphicArray(deque<OJunction*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}


deque<OGraphic*> castOGraphicArray(deque<OQuadrilateral*> & a)
{
	deque<OGraphic*> oa;
	for(int i=0;i<a.size();i++)
		oa.push_back(dynamic_cast<OGraphic*>(a[i]));
	return oa;
}
/**
* OGraphic array to Object array
*/
deque<OGraphicImpl*> castOGraphicImplArray(deque<OGraphic*> & a)
{
	deque<OGraphicImpl*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OGraphicImpl")
			oa.push_back(dynamic_cast<OGraphicImpl*>(a[i]));
	return oa;
}
deque<OPoint*> castOPointArray(deque<OGraphic*> & a)
{
	deque<OPoint*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OPoint")
			oa.push_back(dynamic_cast<OPoint*>(a[i]));
	return oa;
}
deque<ODPoint*> castODPointArray(deque<OGraphic*> & a)
{
	deque<ODPoint*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="ODPoint")
			oa.push_back(dynamic_cast<ODPoint*>(a[i]));
	return oa;
}
deque<OLPoint*> castOLPointArray(deque<OGraphic*> & a)
{
	deque<OLPoint*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OLPoint")
			oa.push_back(dynamic_cast<OLPoint*>(a[i]));
	return oa;
}
deque<OVPoint*> castOVPointArray(deque<OGraphic*> & a)
{
	deque<OVPoint*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OVPoint")
			oa.push_back(dynamic_cast<OVPoint*>(a[i]));
	return oa;
}
deque<OLine*> castOLineArray(deque<OGraphic*> & a)
{
	deque<OLine*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OLine")
			oa.push_back(dynamic_cast<OLine*>(a[i]));
	return oa;
}
deque<OArc*> castOArcArray(deque<OGraphic*> & a)
{
	deque<OArc*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OArc")
			oa.push_back(dynamic_cast<OArc*>(a[i]));
	return oa;
}
deque<OCurve*> castOCurveArray(deque<OGraphic*> & a)
{
	deque<OCurve*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OCurve")
			oa.push_back(dynamic_cast<OCurve*>(a[i]));
	return oa;
}
deque<OHL*> castOHLArray(deque<OGraphic*> & a)
{
	deque<OHL*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OHL")
			oa.push_back(dynamic_cast<OHL*>(a[i]));
	return oa;
}
deque<OGraph*> castOGraphArray(deque<OGraphic*> & a)
{
	deque<OGraph*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OGraph")
			oa.push_back(dynamic_cast<OGraph*>(a[i]));
	return oa;
}
deque<OIPoint*> castOIPointArray(deque<OGraphic*> & a)
{
	deque<OIPoint*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OIPoint")
			oa.push_back(dynamic_cast<OIPoint*>(a[i]));
	return oa;
}
deque<OExtremity*> castOExtremityArray(deque<OGraphic*> & a)
{
	deque<OExtremity*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OExtremity")
			oa.push_back(dynamic_cast<OExtremity*>(a[i]));
	return oa;
}
deque<OJunction*> castOJunctionArray(deque<OGraphic*> & a)
{
	deque<OJunction*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OJunction")
			oa.push_back(dynamic_cast<OJunction*>(a[i]));
	return oa;
}


deque<OQuadrilateral*> castOQuadrilateralArray(deque<OGraphic*> & a)
{
	deque<OQuadrilateral*> oa;
	for(int i=0;i<a.size();i++)
		if(a[i]->getName()=="OQuadrilateral")
			oa.push_back(dynamic_cast<OQuadrilateral*>(a[i]));
	return oa;
}
/**
* OGraphic array print
*/
void printOGraphicArray(deque<OGraphic*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OPoint*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<ODPoint*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OLPoint*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OVPoint*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OLine*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OArc*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OCurve*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OHL*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OGraph*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OIPoint*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OExtremity*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
void printOGraphicArray(deque<OJunction*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}


void printOGraphicArray(deque<OQuadrilateral*> & a)
{
	for(int i=0;i<a.size();i++)
		a[i]->print();
}
