/**	
*   @file	OArc.hpp
*	@author	Mathieu Delalandre, Sebastien Perin
*	@date	05/2004	
*/


/**
*  OArc object
*/
class OArc : public OGraphic  
{
	protected:
		OPoint c,b,e;
		bool isT;
		
		double getDAngle();
		
	public:
		inline OGraphic* clone() const;
		inline OGraphic* create() const;
		OArc();
		OArc(OPoint &,OPoint &,OPoint &,bool);
		~OArc();

		double getRadius();
		bool isLarge();
		double getAngle();
		double getLength();
		bool isSweep();
		bool check();
		
		void gomo(ostream &);
		void gomi(istream &);
		void xmlo(ostream &);
		void svgo(ostream &);

		inline bool isValid();
		inline void clear();
		inline void set(OPoint &,OPoint &,OPoint &);
		inline void setBegin(OPoint &);
		inline void setEnd(OPoint &);
		inline void setCenter(OPoint &);
		inline OPoint getBegin();
		inline OPoint getEnd();
		inline OPoint getCenter();
		inline void setTrigo(bool);
		inline bool isTrigo();
};

/**
*  Clone the arc object
*/
inline OGraphic* OArc::clone() const
	{ return new OArc(*this); }
/**
*  Create the arc object
*/
inline OGraphic* OArc::create() const
	{ return new OArc(); }

inline bool OArc::isValid()
	{ if(b.isValid() && c.isValid() && e.isValid()) return true; return false; }
inline void OArc::clear()
	{ b.clear(); c.clear(); e.clear();}
inline void OArc::set(OPoint & b,OPoint & c,OPoint & e)
	{ this->b = b; this->c = c; this->e = e;}
inline void OArc::setBegin(OPoint & b)
	{ this->b = b;}
inline void OArc::setEnd(OPoint & e)
	{ this->e = e;}
inline void OArc::setCenter(OPoint & c)
	{ this->c = c;}

inline OPoint OArc::getBegin()
	{return b;}
inline OPoint OArc::getEnd()
	{return e;} 
inline OPoint OArc::getCenter()
	{return c;} 
inline void OArc::setTrigo(bool isT)
	{this->isT = isT;} 
inline bool OArc::isTrigo()
	{return isT;} 
