/**	
*   @file	OParallelogram.cpp
*	@author	Omar Hamidou, Mathieu Delalandre
*	@date	07/2004	
*/


/**
*  OParallelogram object
*/
class OQuadrilateral : public OGraphic 
{
	protected:
		OPoint p1,p2,p3,p4,c;

	public:
		inline OGraphic* clone() const;
		inline OGraphic* create() const;
		OQuadrilateral();
		OQuadrilateral(OPoint &,OPoint &,OPoint &,OPoint &);
		OQuadrilateral(OLine &,OLine &);
		~OQuadrilateral();

		bool check();
		OPoint getMiddle();

		OLine medianAxis(); //modification
		double getAngle(); //modification
		double getDistance(OQuadrilateral &); //modification
		
		OLine getUpSide(); //modification
		OLine getLeftSide(); //modification
		OLine getRightSide(); //modification
		OLine getDownSide(); //modification

		OPoint getCenter();
		bool communPoint(OPoint &);
		bool isConnected(OQuadrilateral &);
		bool isTouch(OQuadrilateral &);
		bool isTouch(OLine &);

		bool operator != (OQuadrilateral &);
		bool operator == (OQuadrilateral &);

		void gomo(ostream &);
		void gomi(istream &);
		void xmlo(ostream &);
		void svgo(ostream &);

		inline bool isValid();
		inline void clear();
		inline void setPoints(OPoint &,OPoint &,OPoint &,OPoint &);
		/*
		inline void setPoint1(OPoint &);
		inline void setPoint2(OPoint &);
		inline void setPoint3(OPoint &);
		inline void setPoint4(OPoint &);
		inline OLine getPoint1();
		inline OLine getPoint2();
		inline OLine getPoint3();
		inline OLine getPoint4();
		*/
};

/**
*  Clone the line object
*/
inline OGraphic* OQuadrilateral::clone() const
	{ return new OQuadrilateral(*this); }
/**
*  Create a new line object
*/
inline OGraphic* OQuadrilateral::create() const
	{ return new OQuadrilateral(); }

/**
*  Is valid
*  p1, p2, p3, and p4 no null
*/
inline bool OQuadrilateral::isValid()
	{ if(p1.isValid() && p2.isValid() && p3.isValid() && p4.isValid()) return true; return false;}
/**
*  Clear the p1;p2;p3;p4 lines
*/
inline void OQuadrilateral::clear()
	{ this->p1.clear(); this->p2.clear(); this->p3.clear(); this->p4.clear();}
/**
*  Set the points
*/
inline void OQuadrilateral::setPoints(OPoint & p1, OPoint & p2, OPoint & p3, OPoint & p4)
	{this->p1 = p1; this->p2 = p2; this->p3 = p3; this->p4 = p4;}
/**
*  Set first point
*/
/*
inline void OParallelogram::setPoint1(OPoint & p1)
	{this->p1 = p1;}
*/