/**	
*   @file	POUtility.hpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/

// Object to OGraphic
OGraphic* castOGraphic(OGraphicImpl*);
OGraphic* castOGraphic(OPoint*);
OGraphic* castOGraphic(ODPoint*);
OGraphic* castOGraphic(OLPoint*);
OGraphic* castOGraphic(OVPoint*);
OGraphic* castOGraphic(OLine*);
OGraphic* castOGraphic(OArc*);
OGraphic* castOGraphic(OCurve*);
OGraphic* castOGraphic(OHL*);
OGraphic* castOGraphic(OGraph*);
OGraphic* castOGraphic(OIPoint*);
OGraphic* castOGraphic(OExtremity*);
OGraphic* castOGraphic(OJunction*);

OGraphic* castOGraphic(OQuadrilateral*);

// OGraphic to Object
OGraphicImpl* castOGraphicImpl(OGraphic*);
OPoint* castOPoint(OGraphic*);
ODPoint* castODPoint(OGraphic*);
OLPoint* castOLPoint(OGraphic*);
OVPoint* castOVPoint(OGraphic*);
OLine* castOLine(OGraphic*);
OArc* castOArc(OGraphic*);
OCurve* castOCurve(OGraphic*);
OHL* castOHL(OGraphic*);
OGraph* castOGraph(OGraphic*);
OIPoint* castOIPoint(OGraphic*);
OExtremity* castOExtremity(OGraphic*);
OJunction* castOJunction(OGraphic*);

OQuadrilateral* castOQuadrilateral(OGraphic*);

// Object array to OGraphic array
deque<OGraphic*> castOGraphicArray(deque<OGraphicImpl*> &);
deque<OGraphic*> castOGraphicArray(deque<OPoint*> &);
deque<OGraphic*> castOGraphicArray(deque<ODPoint*> &);
deque<OGraphic*> castOGraphicArray(deque<OLPoint*> &);
deque<OGraphic*> castOGraphicArray(deque<OVPoint*> &);
deque<OGraphic*> castOGraphicArray(deque<OLine*> &);
deque<OGraphic*> castOGraphicArray(deque<OArc*> &);
deque<OGraphic*> castOGraphicArray(deque<OCurve*> &);
deque<OGraphic*> castOGraphicArray(deque<OHL*> &);
deque<OGraphic*> castOGraphicArray(deque<OGraph*> &);
deque<OGraphic*> castOGraphicArray(deque<OIPoint*> &);
deque<OGraphic*> castOGraphicArray(deque<OExtremity*> &);
deque<OGraphic*> castOGraphicArray(deque<OJunction*> &);

deque<OGraphic*> castOGraphicArray(deque<OQuadrilateral*> &);

// OGraphic array to Object array
deque<OGraphicImpl*> castOGraphicImplArray(deque<OGraphic*> &);
deque<OPoint*> castOPointArray(deque<OGraphic*> &);
deque<ODPoint*> castODPointArray(deque<OGraphic*> &);
deque<OLPoint*> castOLPointArray(deque<OGraphic*> &);
deque<OVPoint*> castOVPointArray(deque<OGraphic*> &);
deque<OLine*> castOLineArray(deque<OGraphic*> &);
deque<OArc*> castOArcArray(deque<OGraphic*> &);
deque<OCurve*> castOCurveArray(deque<OGraphic*> &);
deque<OHL*> castOHLArray(deque<OGraphic*> &);
deque<OGraph*> castOGraphArray(deque<OGraphic*> &);
deque<OIPoint*> castOIPointArray(deque<OGraphic*> &);
deque<OExtremity*> castOExtremityArray(deque<OGraphic*> &);
deque<OJunction*> castOJunctionArray(deque<OGraphic*> &);

deque<OQuadrilateral*> castOQuadrilateralArray(deque<OGraphic*> &);

// print array
void printOGraphicArray(deque<OGraphic*> &);
void printOGraphicArray(deque<OPoint*> &);
void printOGraphicArray(deque<ODPoint*> &);
void printOGraphicArray(deque<OLPoint*> &);
void printOGraphicArray(deque<OVPoint*> &);
void printOGraphicArray(deque<OLine*> &);
void printOGraphicArray(deque<OArc*> &);
void printOGraphicArray(deque<OCurve*> &);
void printOGraphicArray(deque<OHL*> &);
void printOGraphicArray(deque<OGraph*> &);
void printOGraphicArray(deque<OIPoint*> &);
void printOGraphicArray(deque<OExtremity*> &);
void printOGraphicArray(deque<OJunction*> &);

void printOGraphicArray(deque<OQuadrilateral*> &);

