/**	
*   @file	ALink.hpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/

/**
*  ALink attribute object
*  an attribute to modelling the objects' begins and ends
*/
class ALink : public AGraphic
{
	protected:
		int from,to;
		string linkLabel(int);
	
	public:
		static int begin,end,center;

		inline AGraphic* clone() const;
		inline AGraphic* create() const;
		ALink();
		ALink(int,int);
		~ALink();
		
		void gomo(ostream &);
		void gomi(istream &);
		void xmlo(ostream &);

		inline void setLink(int,int);
		inline int getFrom();
		inline int getTo();
};

inline AGraphic* ALink::clone() const
	{ return new ALink(*this); }
inline AGraphic* ALink::create() const
	{ return new ALink(); }

/**
* fE true start from end, false start from begin
* tB true go to begin, false go to end
*/
void ALink::setLink(int fE,int tB)
	{ this->from = from; this->to = to;}
/**
* true end, false begin
*/
int ALink::getFrom()
	{ return from;}
/**
* true begin, false end
*/
int ALink::getTo()
	{ return to;}
