/**	
*   @file	ODPoint.hpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/


/**
*  ODPoint object
*  a depth point object
*/
class ODPoint : public OPoint
{
	protected:
		int d;
	public:
		inline OGraphic* clone() const;
		inline OGraphic* create() const;
		ODPoint();
		ODPoint(int,int,int=1);
		ODPoint(OPoint &,int=1);
		~ODPoint();

		bool isValid();
		void move(int,int,int=0);

		bool operator == (ODPoint &);
		bool operator != (ODPoint &);

		void gomo(ostream &);
		void gomi(istream &);
		void xmlo(ostream &);

		void clear();
		inline void setDepth(int);
		inline int getDepth();
		inline int getDDepth(ODPoint &);
};

inline OGraphic* ODPoint::clone() const
	{ return new ODPoint(*this); }
inline OGraphic* ODPoint::create() const
	{ return new ODPoint(); }

inline void ODPoint::clear()
	{ this->x = -1; this->y = -1; this->d = -1; }
inline int ODPoint::getDepth()
	{ return d; }
inline void ODPoint::setDepth(int d)
	{ this->d = d; }
inline int ODPoint::getDDepth(ODPoint & p)
	{return p.getDepth()-d;}

