/**	
*   @file	OLPoint.hpp
*	@author	Mathieu Delalandre
*	@date	06/2004	
*/


/**
*  A label point object
*/
class OLPoint : public OPoint
{
	protected:
		string label;
	public:
		inline OGraphic* clone() const;
		inline OGraphic* create() const;
		OLPoint();
		OLPoint(int,int,string &);
		OLPoint(OPoint &,string &);
		~OLPoint();
		
		bool isValid();
		
		void gomo(ostream &);
		void gomi(istream &);
		void xmlo(ostream &);
		void svgo(ostream &);

		inline void clear();
		inline void setLabel(string &);
		inline string getLabel();
};

inline OGraphic* OLPoint::clone() const
	{ return new OLPoint(*this); }
inline OGraphic* OLPoint::create() const
	{ return new OLPoint(); }

inline void OLPoint::clear()
	{ this->x = -1; this->y = -1; this->label = "none"; }
inline void OLPoint::setLabel(string & label)
	{ this->label = label; }
inline string OLPoint::getLabel()
	{ return label; }
