/**	\file	TreatCMatching.hpp
*	\author	Omar Hamidou, Mathieu Delalandre
*	\date	07/04
*/

/**
* Matching object
*/
class Matching
	{
	public:
		double r1,r2,r3;
		int l1,l2;
	
		Matching();
		Matching(int,int,double,double,double);
		
		bool sameOne(Matching &);
		bool sameTwo(Matching &);
		bool isUpperMatching(Matching &);
};

/**
* Contour Matching
*/
class CMatch
	{
	protected:
		double th;
		
		deque<OLine*> la; //line array
		deque<Matching> ms; //matching set
		deque<OGraphic*> pa; //parallelogram array

		bool *LTab; //modification bon
		void initLArray(); //modification bon
		void unmatched(); //modification bon
		
		bool isLineLoop(OHL*);
		void closeLoop(OHL*);
		void match();
		
		void findMatching();
		bool toMatch(OLine &,OLine &);
		void matching(int,int);
		double gapStroke(OLine &,OLine  &);

		void dualMatchingFilter();
		void strokeFilter();
		void fuzzySort();
		void performMatching();

		void printTabMatching();
		void printMatching(int);

		void checkLength(OLine &,OLine &); //modification

		void becomeOHL(); //modification
		deque<OGraphic*> npa; //modification

		void clear();

	public:
		CMatch();
		~CMatch();
		deque<OGraphic*> match(deque<OHL*> & ha,double );
		deque<OGraphic*> unmatch(deque<OHL*> & hae,double th);
		OHL *pae; //modification  bon
		//deque<OGraphic*> npa;
		OHL *all; //modification
	};

