/**	\file	DataImage.hpp
*	\author	mathieu delalandre
*	\date	04/2003	
*/

/**
* image class
*/
class Image
	{
	private:
		//class member
		int	    width;
		int	    heigth;
		int	    size;
		int		**raster;
	public:
		//creation
		Image();
		~Image();
		rasterCreate(int, int);	
		void rasterInit(int);
		//class member acces
		void pixelWrite(int,int,int);
		int pixelRead(int,int);
		int pixelReadNorm(int,int);
		inline int getWidth();
		inline int getHeight();
		inline int getSize();
		//other function
		void shellPrintInt();
		void shellPrintInt(int,int,int,int);
		void shellPrintChar();
		void shellPrintChar(int,int,int,int);
		Image* copy();
		Image* copy(int,int,int,int);
		void frameInitialisation();
		Image* borderAdd();
		void inversion();
		void absolute();
		void normalize();
	};

inline int Image::getWidth()
	{ return(width); }
inline int Image::getHeight()
	{ return(heigth);}
inline int Image::getSize()
	{ return(size); }
